package javax.swing.plaf.metal;

import javax.swing.plaf.UIResource;
import java.awt.Graphics;
import java.awt.Component;
import javax.swing.border.AbstractBorder;
import java.awt.Dimension;
import javax.swing.JTextField;
import java.awt.Insets;
import javax.swing.plaf.basic.BasicComboBoxEditor;

public class MetalComboBoxEditor extends BasicComboBoxEditor
{
    protected static Insets editorBorderInsets;
    
    public MetalComboBoxEditor() {
        (this.editor = new JTextField("", 9) {
            @Override
            public void setText(String s) {
                if (this.getText().equals(s)) {
                    return;
                }
                super.setText(s);
                return;
            }
            
            @Override
            public Dimension getPreferredSize() {
                Dimension preferredSize = super.getPreferredSize();
                preferredSize.height += 4;
                return preferredSize;
            }
            
            @Override
            public Dimension getMinimumSize() {
                Dimension minimumSize = super.getMinimumSize();
                minimumSize.height += 4;
                return minimumSize;
            }
        }).setBorder(new MetalComboBoxEditor.EditorBorder());
    }
    
    static {
        MetalComboBoxEditor.editorBorderInsets = new Insets(2, 2, 2, 0);
    }
    
    class EditorBorder extends AbstractBorder
    {
        @Override
        public void paintBorder(Component component, Graphics graphics, int n, int n2, int width, int n3) {
            graphics.translate(n, n2);
            if (MetalLookAndFeel.usingOcean()) {
                graphics.setColor(MetalLookAndFeel.getControlDarkShadow());
                graphics.drawRect(0, 0, width, n3 - 1);
                graphics.setColor(MetalLookAndFeel.getControlShadow());
                graphics.drawRect(1, 1, width - 2, n3 - 3);
            }
            else {
                graphics.setColor(MetalLookAndFeel.getControlDarkShadow());
                graphics.drawLine(0, 0, width - 1, 0);
                graphics.drawLine(0, 0, 0, n3 - 2);
                graphics.drawLine(0, n3 - 2, width - 1, n3 - 2);
                graphics.setColor(MetalLookAndFeel.getControlHighlight());
                graphics.drawLine(1, 1, width - 1, 1);
                graphics.drawLine(1, 1, 1, n3 - 1);
                graphics.drawLine(1, n3 - 1, width - 1, n3 - 1);
                graphics.setColor(MetalLookAndFeel.getControl());
                graphics.drawLine(1, n3 - 2, 1, n3 - 2);
            }
            graphics.translate(-n, -n2);
        }
        
        @Override
        public Insets getBorderInsets(Component component, Insets insets) {
            insets.set(2, 2, 2, 0);
            return insets;
        }
    }
    
    public static class UIResource extends MetalComboBoxEditor implements javax.swing.plaf.UIResource
    {
    }
}
